Namespace ExpressLane.Concurrency
	''' <summary>
	''' ʾһ첽ִеδ
	''' </summary>
	Friend Class AsyncResultFuture(Of TResult)
		Implements IFuture(Of TResult)
		Private m_asyncResult As IAsyncResult
		Private m_delegate As Func(Of TResult)
		''' <summary>
		''' һµδ
		''' </summary>
		Public Sub New(ByVal asyncResult As IAsyncResult, ByVal targetDelegate As Func(Of TResult))
			m_asyncResult = asyncResult
			m_delegate = targetDelegate
		End Sub
		''' <summary>
		''' ȡǰִСδʵ֡
		''' </summary>
		Public Sub Cancel() Implements IFuture(Of TResult).Cancel
			Throw New NotImplementedException
		End Sub
		''' <summary>
		''' ȡڵȴ첽ɵ System.Threading.WaitHandle
		''' </summary>
		Public ReadOnly Property FutureWaitHandle() As System.Threading.WaitHandle Implements IFuture(Of TResult).FutureWaitHandle
			Get
				Return Me.m_asyncResult.AsyncWaitHandle
			End Get
		End Property
		''' <summary>
		''' ôĽ
		''' </summary>
		Public Function GetResult() As TResult Implements IFuture(Of TResult).GetResult
			WaitForComplete()
			Return m_delegate.EndInvoke(m_asyncResult)
		End Function
		''' <summary>
		''' ȡǷѱȡ
		''' </summary>
		Public ReadOnly Property IsCanceled() As Boolean Implements IFuture(Of TResult).IsCanceled
			Get
				Return False
			End Get
		End Property
		''' <summary>
		''' ȡǷɡ
		''' </summary>
		Public ReadOnly Property IsCompleted() As Boolean Implements IFuture(Of TResult).ISCompleted
			Get
				Return Me.m_asyncResult.IsCompleted
			End Get
		End Property
		''' <summary>
		''' ȴֱɡ
		''' </summary>
		Public Sub WaitForComplete() Implements IFuture(Of TResult).WaitForComplete
			Do Until Me.m_asyncResult.IsCompleted

			Loop
		End Sub
	End Class
	''' <summary>
	''' ṩһڳ첽ִִߡ
	''' </summary>
	Friend Class AsyncInvokeExecutor
		Implements IExecutorLifecycleExtension

		''' <summary>
		''' 첽ִһ ThreadStart
		''' </summary>
		Public Sub Execute(ByVal proc As System.Threading.ParameterizedThreadStart, ByVal state As Object) Implements IExecutor.Execute
			proc.BeginInvoke(state, Nothing, Nothing)
		End Sub
		''' <summary>
		''' 첽ִһ ParameterizedThreadStart
		''' </summary>
		Public Sub Execute(ByVal proc As System.Threading.ThreadStart) Implements IExecutor.Execute
			proc.BeginInvoke(Nothing, Nothing)
		End Sub

		''' <summary>
		''' ʾ̳߳صǰ״̬
		''' </summary>
		Public Sub Abort() Implements IExecutorLifecycleExtension.Abort
			Throw New NotSupportedException()
		End Sub

		''' <summary>
		''' ʾ̳߳صǰ״̬
		''' </summary>
		Public ReadOnly Property State() As ExecutorState Implements IExecutorLifecycleExtension.State
			Get
				Return ExecutorState.Running
			End Get
		End Property

		''' <summary>
		''' 첽ִһ Func(Of TArg, TResult) TResult
		''' </summary>
		Public Function SubmitTask(Of TResult)(ByVal proc As Func(Of TResult)) As IFuture(Of TResult) Implements IExecutorLifecycleExtension.SubmitTask
			Dim asyncResult As IAsyncResult = proc.BeginInvoke(Nothing, Nothing)
			Return New AsyncResultFuture(Of TResult)(asyncResult, proc)
		End Function
		''' <summary>
		''' 첽ִһ޲ Func(Of TResult) TResult
		''' </summary>
		Public Function SubmitTask(ByVal proc As System.Threading.ParameterizedThreadStart, ByVal state As Object) As IFuture(Of SubroutineReturnType) Implements IExecutorLifecycleExtension.SubmitTask
			Dim procWrap As New ParameterizedThreadStartWrapper(proc, state)
			Dim procDelegate As Func(Of SubroutineReturnType) = procWrap.ToDelegate

			Dim asyncResult As IAsyncResult = procDelegate.BeginInvoke(Nothing, Nothing)
			Return New AsyncResultFuture(Of SubroutineReturnType)(asyncResult, procDelegate)
		End Function
		''' <summary>
		''' 첽ִһ ThreadStart SubroutineReturnType
		''' </summary>
		Public Function SubmitTask(ByVal proc As System.Threading.ThreadStart) As IFuture(Of SubroutineReturnType) Implements IExecutorLifecycleExtension.SubmitTask
			Dim procWrap As New ThreadStartWrapper(proc)
			Dim procDelegate As Func(Of SubroutineReturnType) = procWrap.ToDelegate

			Dim asyncResult As IAsyncResult = procDelegate.BeginInvoke(Nothing, Nothing)
			Return New AsyncResultFuture(Of SubroutineReturnType)(asyncResult, procDelegate)
		End Function
		''' <summary>
		''' 첽ִһ ParameterizedThreadStart SubroutineReturnType
		''' </summary>
		Public Function SubmitTask(Of TArg, TResult)(ByVal proc As Func(Of TArg, TResult), ByVal state As TArg) As IFuture(Of TResult) Implements IExecutorLifecycleExtension.SubmitTask
			Dim procWrap As New UnaryFuncWrapper(Of TArg, TResult)(proc, state)
			Dim procDelegate As Func(Of TResult) = procWrap.ToDelegate

			Dim asyncResult As IAsyncResult = procDelegate.BeginInvoke(Nothing, Nothing)
			Return New AsyncResultFuture(Of TResult)(asyncResult, procDelegate)
		End Function

		''' <summary>
		''' ȴֱ̳߳ȫֹͣ
		''' </summary>
		Public Sub WaitForAbort() Implements IExecutorLifecycleExtension.WaitForAbort
			Throw New NotSupportedException
		End Sub
		''' <summary>
		''' ָһʱȴֱ̳߳ȫֹͣ
		''' </summary>
		Public Function WaitForAbort(ByVal timeOut As System.TimeSpan) As Boolean Implements IExecutorLifecycleExtension.WaitForAbort
			Throw New NotSupportedException
		End Function
	End Class
End Namespace