Imports ExpressLane.Concurrency
Imports System.Threading

Module Demo

	Sub Main()
		Dim executor As IExecutorLifecycleExtension = ExecutorFactory.CreateAsyncInvokeExecutor()
		executor.Execute(AddressOf Test1)

		Dim future1 As IFuture(Of SubroutineReturnType) = executor.SubmitTask(AddressOf Test2, 1)

		Dim future2 As IFuture(Of Integer) = executor.SubmitTask(Of Integer, Integer)(AddressOf Test3, 2)

		Dim result As Integer = future2.GetResult()

		Console.WriteLine("Final result: {0}", result)
	End Sub

	Sub Test1()
		Thread.Sleep(1000)
		Console.WriteLine("Test 1 finished")
	End Sub

	Sub Test2(ByVal x As Object)
		Thread.Sleep(2000)
		Console.WriteLine("Test 2 finished, state = {0}", x)
	End Sub

	Function Test3(ByVal x As Integer) As Integer
		Thread.Sleep(3000)
		Console.WriteLine("Test 3 finished")

		Return x + 1
	End Function
End Module
